% This script produce all the figures contained in "Obtaining Binaural Room
% Impulse Responses from B-Format Impulse Responses using
% Frequency-Dependent Coherence Matching"

% clear all variables
clear

cd tools

% run the B-Format RIR to BRIR conversion once
completeseparation5

% close all windows
close all;

% To turn on exporting of the pictures set the following variables to 1:
fsave=0;
savefigs=0;

% figure 1 (B-Format mics)
bformatplot

% figure 2 (direct sound separation)
plotDirSoundSep

% figures 3 and 4 (directional responses, v versus phi)
makePlotDirResp_vvsPhi

% figures 5 and 6 (BRIR spectra)
figures_analysis_brir

% figures 7 and 8 (coherence plots)
plotCohAllBrir

% figure 9 (linear decoding responses)
lineardecoding_plot

% figure 10 (waveforms)
makewaveformplots

% figures 12, 13, and 14 (listening test results)
% - data missing
% plotListeningTestResultsCombined

cd ..