function i=cart2inter(c)
% function i=cart2inter(c)
%
% cartesian to interaural polar coordinates
%
% c = [x y z]
% i = [r azimuth elevation]

x=c(1);
y=c(2);
z=c(3);

r=sqrt(sum(c.^2));
azi=real(asin(x/r)/pi*180);
ele=-real(atan2(y,z)/pi*180)+90;

i=[r,azi,ele];