function v=cart2vert(c)
% function v=cart2vert(c)
%
% cartesian to vertical polar coordinates
%
% c = [x y z]
% v = [r azimuth elevation]

x=c(1);
y=c(2);
z=c(3);

r=sqrt(sum(c.^2));
azi=atan2(x,y)/pi*180;
rxy=sqrt(sum(c(1:2).^2));
ele=atan2(z,rxy)/pi*180;

v=[r,azi,ele];