load reference_brir

fs=44100;

% do plot for late BRIR
figure(6);

f = (500:length(h441)/2).*fs/length(h441);

split=round(zidx/96*44.1);

h441l=h441;
h441l(1:split)=0;
brirl=brirspm;
brirl(1:split)=0;

BRIRL=abs(fft(brirl(:,1)));
H441L=abs(fft(h441l(:,1)));

H441L=H441L*sqrt(sum(BRIRL.^2)/sum(H441L.^2));

semilogx(f, 20*log10(smooth(BRIRL(501:floor(length(h441)/2)+1),1000))+32, 'k');
hold on
h=semilogx(f, 20*log10(smooth(H441L(501:floor(length(h441)/2)+1),1000))+32, 'k');
set(h,'lineWidth',1.5)

axis tight
grid on
xlabel('Frequency [Hz]')
ylabel('Magnitude [dB]')
legend('Generated late BRIR','Measured late BRIR',2)

hp=get(h,'Parent');
set(hp,'Position',[0.13 0.35 0.5 0.5]);
%set(hp,'YTick',[0,0.2,0.4,0.6,0.8,1]);

axis([170,10000,-10,20]);

if fsave == 1
  print -depsc 'latebrirspect.eps'
end

% do plot for all the BRIR
figure(5)

BRIR=abs(fft(brirspm(:,1)));
H441=abs(fft(h441(:,1)));

H441=H441*sqrt(sum(BRIR.^2)/sum(H441.^2));

semilogx(f, 20*log10(smooth(BRIR(501:floor(length(h441)/2)+1),1000))+32, 'k');
hold on
h=semilogx(f, 20*log10(smooth(H441(501:floor(length(h441)/2)+1),1000))+32, 'k');
set(h,'lineWidth',1.5)

axis tight
grid on
xlabel('Frequency [Hz]')
ylabel('Magnitude [dB]')
legend('Generated BRIR','Measured BRIR',2)

hp=get(h,'Parent');
set(hp,'Position',[0.13 0.35 0.5 0.5]);

axis([170,10000,-10,20]);

if fsave == 1
  print -depsc 'brirspect.eps'
end


% make coherence plot
%plotCohAllBrir