function x=istft(X,w)

if nargin<2, w=sqrt(hann((size(X,1)-1)*2)); end

M = length(w);           % M = window length, N = FFT length
Mo2 = M/2;
R = Mo2;
N = M;
nframes=size(X,2);
x = zeros(R*(nframes+1),1); % pre-allocate STFT output array
xoff = 0;                % current offset in input signal x
for m=1:nframes
    Xframe=[X(:,m);conj(X(end-1:-1:2,m))];
    xframe=ifft(Xframe);
    xframeUnshifted=[xframe(Mo2+1:M);xframe(1:Mo2)];
    x(xoff+1:xoff+M)=x(xoff+1:xoff+M)+xframeUnshifted.*w;
    xoff = xoff + R;       % advance in-pointer by hop-size R
end
x=real(x);