if exist('fsave','var')==0
    fsave=0;
end

load brirs0deg

nwin = 256;
%split=4015; % 80 ms (there are 485 samples silence before direct sound)
split=7100; % 150 ms

refbrir(end,1)=refbrir(end,1); % otherwise, Matlab is confused - odd...
[S1] = stft(refbrir(split:end,1), hamming(nwin));
[S2] = stft(refbrir(split:end,2), hamming(nwin));

for i = 1:(nwin/2+1),
  p1(i)  = mean(abs(S1(i,:).^2));
  p2(i)  = mean(abs(S2(i,:).^2));
  cohref(i) = abs(mean(S1(i,:).*conj(S2(i,:)))) / sqrt(p1(i)*p2(i));
end

brir_l(end)=brir_l(end); % otherwise, Matlab is confused
brir_r(end)=brir_r(end); % otherwise, Matlab is confused
%[S1] = stft(genbrir(split:end,1), hamming(nwin));
%[S2] = stft(genbrir(split:end,2), hamming(nwin));
[S1] = stft(brir_l(split:end), hamming(nwin));
[S2] = stft(brir_r(split:end), hamming(nwin));

for i = 1:(nwin/2+1),
  p1(i)  = mean(abs(S1(i,:).^2));
  p2(i)  = mean(abs(S2(i,:).^2));
  cohgen(i) = abs(mean(S1(i,:).*conj(S2(i,:)))) / sqrt(p1(i)*p2(i));
end

c3brir(end)=c3brir(end); % otherwise, Matlab is confused - odd...
[S1] = stft(c3brir(split:end,1), hamming(nwin));
[S2] = stft(c3brir(split:end,2), hamming(nwin));

for i = 1:(nwin/2+1),
  p1(i)  = mean(abs(S1(i,:).^2));
  p2(i)  = mean(abs(S2(i,:).^2));
  cohc3(i) = abs(mean(S1(i,:).*conj(S2(i,:)))) / sqrt(p1(i)*p2(i));
end

c4brir(end)=c4brir(end); % otherwise, Matlab is confused - odd...
[S1] = stft(c4brir(split:end,1), hamming(nwin));
[S2] = stft(c4brir(split:end,2), hamming(nwin));

for i = 1:(nwin/2+1),
  p1(i)  = mean(abs(S1(i,:).^2));
  p2(i)  = mean(abs(S2(i,:).^2));
  cohc4(i) = abs(mean(S1(i,:).*conj(S2(i,:)))) / sqrt(p1(i)*p2(i));
end

% calculate coherence directly from HRTFs
readHRTFs2
N=length(h);
NHRTF = length(h{1});
H=cell(1,N);
for i = 1:N,
  tmp = fft([h{i}; zeros(nwin-NHRTF,2)]);
  H{i} = tmp(1:(nwin/2+1),:);
end

num  = 0;
den1 = 0;
den2 = 0;
for i = 1:N,
  num  = num + (H{i}(:,1).*conj(H{i}(:,2)));
  den1 = den1 + abs(H{i}(:,1).*conj(H{i}(:,1)));
  den2 = den2 + abs(H{i}(:,2).*conj(H{i}(:,2)));
end
cohhrtf2 = abs(num) ./ sqrt(den1.*den2);


figure(7)
f = (0:(nwin/2)).*fs/nwin;

h=semilogx(f, cohref, 'k');
set(h,'lineWidth',1.5)
hold on

%freqs_=freqs(1:100:end);
%Phi_=Phi(1:100:end);
%h=semilogx(freqs_, Phi_, 'k:');
h=semilogx(f, cohhrtf2, 'k:');
set(h,'lineWidth',1.5)

semilogx(f, cohgen, 'k');
hold off

axis tight
grid on
xlabel('Frequency [Hz]')
ylabel('Coherence \Phi')
legend('Measured late BRIR','HRTF-based Prediction','Generated late BRIR',1)

hp=get(h,'Parent');
set(hp,'Position',[0.13 0.35 0.5 0.5]);
set(hp,'YTick',[0,0.2,0.4,0.6,0.8,1]);

axis([170,10000,0,1]);

if fsave == 1
  print -depsc 'lbrgencoh150.eps'
end

figure(8)
h=semilogx(f, cohref, 'k');
set(h,'lineWidth',1.5)
hold on

h=semilogx(f, cohc3, 'k:');
set(h,'lineWidth',1.5)

semilogx(f, cohc4, 'k');
hold off

axis tight
grid on
xlabel('Frequency [Hz]')
ylabel('Coherence \Phi')
legend('Measured late BRIR','3-Cardioid BRIR','4-Cardioid BRIR',2)

hp=get(h,'Parent');
set(hp,'Position',[0.13 0.35 0.5 0.5]);
set(hp,'YTick',[0,0.2,0.4,0.6,0.8,1]);

axis([170,10000,0,1]);

if fsave == 1
  print -depsc 'lbrcardcoh150.eps'
end

split=700;

[S1] = stft(refbrir(split:end,1), hamming(nwin));
[S2] = stft(refbrir(split:end,2), hamming(nwin));

for i = 1:(nwin/2+1),
  p1(i)  = mean(abs(S1(i,:).^2));
  p2(i)  = mean(abs(S2(i,:).^2));
  cohref(i) = abs(mean(S1(i,:).*conj(S2(i,:)))) / sqrt(p1(i)*p2(i));
end

%[S1] = stft(genbrir(split:end,1), hamming(nwin));
%[S2] = stft(genbrir(split:end,2), hamming(nwin));
[S1] = stft(brir_l(split:end), hamming(nwin));
[S2] = stft(brir_r(split:end), hamming(nwin));

for i = 1:(nwin/2+1),
  p1(i)  = mean(abs(S1(i,:).^2));
  p2(i)  = mean(abs(S2(i,:).^2));
  cohgen(i) = abs(mean(S1(i,:).*conj(S2(i,:)))) / sqrt(p1(i)*p2(i));
end

figure(107)

h=semilogx(f, cohref, 'k');
set(h,'lineWidth',1.5)
hold on

semilogx(f, cohgen, 'k');
hold off

axis tight
grid on
xlabel('Frequency [Hz]')
ylabel('Coherence \Phi')
legend('Measured late BRIR','Generated late BRIR',1)

hp=get(h,'Parent');
set(hp,'Position',[0.13 0.35 0.5 0.5]);
set(hp,'YTick',[0,0.2,0.4,0.6,0.8,1]);

axis([170,10000,0,1]);

if fsave == 1
  print -depsc 'lbrgencoh.eps'
end
