% little script to illustrate reading HRTFs

% setup data for CIPIC hrtfs
if ~exist('D','var')
    cd ../../hrtfs/CIPIC/
    D=setupHRTFs();
    cd ../../bformat_hrtf/matlab/
end

% calculate weights proportional to the area of spherical cap
w60=2*pi*(1-cos(45/180*pi / 2)); % 45 deg and up
w30=2*pi*(1-cos(75/180*pi / 2))-w60; % 15 deg - 45 deg
w0=2*pi*(1-cos(105/180*pi / 2))-w30; %-15 deg - 15 deg


% get HRTFs every 10 degrees (independent of HRTF database)
h={};
ele = 0;
for azi=0:5:355
h{end+1}=w0*hrtf(azi,ele,D);
end
ele = 30;
for azi=0:5:355
h{end+1}=w30*hrtf(azi,ele,D);
end
ele = -30;
for azi=0:5:355
h{end+1}=w30*hrtf(azi,ele,D);
end
ele = 60;
for azi=0:5:355
h{end+1}=w60*hrtf(azi,ele,D);
end
ele = -60;
for azi=0:5:355
h{end+1}=w60*hrtf(azi,ele,D);
end

% output: cell array, where each cell contains the HRTF for one angle.