function X=stft(x,w)

if length(w)==1, w=sqrt(hann(w)); end

M = length(w);           % M = window length, N = FFT length
Mo2 = M/2;
R = Mo2;
N = M;
nframes=floor(length(x)/R)-1;
Xtwz = zeros(N,nframes); % pre-allocate STFT output array
zp = zeros(N-M,1);       % zero padding (to be inserted)
xoff = 0;                % current offset in input signal x
for m=1:nframes
  xt = x(xoff+1:xoff+M); % extract frame of input data
  xtw = w .* xt;         % apply window to current frame
  xtwz = [xtw(Mo2+1:M); zp; xtw(1:Mo2)]; % windowed, zero padded
  Xtwz(:,m) = fft(xtwz); % STFT for frame m
  xoff = xoff + R;       % advance in-pointer by hop-size R
end
X=Xtwz(1:Mo2+1,:);