function [h,hzoom]=zoomplot(x,y,zoom1,zoomend,rect,xlbl,ylbl,ttl,style,frame,ytick)

if nargin<9, style=''; end

xz=x(zoom1:zoomend);
yz=y(zoom1:zoomend,:);
axz=niceaxis(xz,yz,0.1);

h=plot(x,y,style);
ax=niceaxis(x,y);
axis(ax);
if nargin>=6, xlabel(xlbl); end
if nargin>=7, ylabel(ylbl); end
if nargin>=8, title(ttl); end

hp=get(h(1),'parent');
if nargin>=10
    set(hp,'position',frame);
else
    frame=get(hp,'position');
end
if nargin>=11
    set(hp,'YTick',ytick);
end

left=ax(1)+(rect(1)-frame(1))/frame(3)*(ax(2)-ax(1));
bottom=ax(3)+(rect(2)-frame(2))/frame(4)*(ax(4)-ax(3));
right=ax(1)+(rect(1)+rect(3)-frame(1))/frame(3)*(ax(2)-ax(1));
top=ax(3)+(rect(2)+rect(4)-frame(2))/frame(4)*(ax(4)-ax(3));

hl=line([axz(1),left],[axz(3),bottom]);
hl(end+1)=line([axz(2),right],[axz(3),bottom]);
hl(end+1)=line([axz(1),left],[axz(4),top]);
hl(end+1)=line([axz(2),right],[axz(4),top]);
hl(end+1)=line([axz(1),axz(2)],[axz(3),axz(3)]);
hl(end+1)=line([axz(2),axz(2)],[axz(3),axz(4)]);
hl(end+1)=line([axz(2),axz(1)],[axz(4),axz(4)]);
hl(end+1)=line([axz(1),axz(1)],[axz(4),axz(3)]);
set(hl,'lineStyle',':')
set(hl,'color',[0,0,0])

% draw box
axes('position',rect);
hzoom=plot(xz,yz,style);
axis(axz)
if nargin>=11
    hp=get(hzoom(1),'Parent');
    set(hp,'YTick',ytick);
end
